Index: /trunk/SophyaLib/BaseTools/Makefile
===================================================================
--- /trunk/SophyaLib/BaseTools/Makefile	(revision 3402)
+++ /trunk/SophyaLib/BaseTools/Makefile	(revision 3403)
@@ -1,4 +1,4 @@
 include ../BuildMgr/sophyamake.inc
-
+ 
 all: $(SOPHYALIBP)libBaseTools.a
  
@@ -67,5 +67,5 @@
   pexceptions.h ppersist.h gnumd5.h ppfbinstream.h rawstream.h \
   ppfnametag.h fiondblock.h ndatablock.h anydataobj.h dvlist.h objfio.h \
-  mutyv.h timestamp.h fiosegdb.h segdatablock.h thsafeop.h \
+  mutyv.h timestamp.h stsrand.h fiosegdb.h segdatablock.h thsafeop.h \
   ppftpointerio.h ppfwrapstlv.h sversion.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  sophyainit.cc
@@ -74,5 +74,5 @@
   $(SOPHYAINCP)machdefs.h objfio.h anydataobj.h \
   ppersist.h pexceptions.h gnumd5.h ppfbinstream.h rawstream.h \
-  ppfnametag.h ndatablock.h thsafeop.h srandgen.h fiondblock.h
+  ppfnametag.h ndatablock.h thsafeop.h fiondblock.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  stsrand.cc
  
Index: /trunk/SophyaLib/BaseTools/smakefile
===================================================================
--- /trunk/SophyaLib/BaseTools/smakefile	(revision 3402)
+++ /trunk/SophyaLib/BaseTools/smakefile	(revision 3403)
@@ -67,5 +67,5 @@
   pexceptions.h ppersist.h gnumd5.h ppfbinstream.h rawstream.h \
   ppfnametag.h fiondblock.h ndatablock.h anydataobj.h dvlist.h objfio.h \
-  mutyv.h timestamp.h fiosegdb.h segdatablock.h thsafeop.h \
+  mutyv.h timestamp.h stsrand.h fiosegdb.h segdatablock.h thsafeop.h \
   ppftpointerio.h ppfwrapstlv.h sversion.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  sophyainit.cc
@@ -74,5 +74,5 @@
   $(SOPHYAINCP)machdefs.h objfio.h anydataobj.h \
   ppersist.h pexceptions.h gnumd5.h ppfbinstream.h rawstream.h \
-  ppfnametag.h ndatablock.h thsafeop.h srandgen.h fiondblock.h
+  ppfnametag.h ndatablock.h thsafeop.h fiondblock.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  stsrand.cc
  
Index: /trunk/SophyaLib/BaseTools/stsrand.cc
===================================================================
--- /trunk/SophyaLib/BaseTools/stsrand.cc	(revision 3402)
+++ /trunk/SophyaLib/BaseTools/stsrand.cc	(revision 3403)
@@ -1,7 +1,8 @@
 #include "stsrand.h"
 #include "thsafeop.h"
-#include "srandgen.h"
+//#include "srandgen.h"
 #include "fiondblock.h"
 #include <math.h> 
+#include <sys/time.h>
 
 namespace SOPHYA {
@@ -57,10 +58,67 @@
 
 void RandomGenerator::AutoInit(int lp)
-{
-  if (ths_rand == NULL)  ths_rand = new ThSafeOp; 
-  ths_rand->lock();
-  if(lp) cout << "RandomGenerator::AutoInit() : Calling Auto_Ini_Ranf() ..." << endl;
-  Auto_Ini_Ranf(lp);  // Faut-il faire copier/coller du code Auto_Ini_Ranf() ici ? 
-  ths_rand->unlock();
+// Initialisation automatique (pseudo) aleatoire du generateur.
+// L'initialiseur est donne par un codage du nombre de millisecondes
+// ecoulees depuis le 0 heure le 1er Janvier 1970 UTC (cf gettimeofday).
+// Seuls les 48 bits de poids faible sont retenus.
+// Un melange des bits est ensuite effectue pour que les 3 nombres
+// (unsigned short) d'initialisation ne soient pas trop semblables.
+//
+// Le nombre le plus grand que l'on peut mettre
+// dans un entier unsigned de N bits est: 2^N-1
+// 48 bits -> 2^48-1 = 281474976710655 musec = 3257.8j = 8.9y
+//         -> meme initialisation tous les 8.9 ans a 1 microsec pres !
+{
+  // On recupere le temps ecoule depuis l'origine code en sec+musec
+  struct timeval now;
+  gettimeofday(&now,0);
+
+  // Calcul du temps ecoule depuis l'origine en microsecondes
+  uint_8 v = (uint_8)now.tv_sec*(uint_8)1000000 + (uint_8)now.tv_usec;
+  if(lp>1) cout<<"..."<<now.tv_sec<<" sec + "<<now.tv_usec<<" musec = "<<v<<" musec"<<endl;
+
+  // Remplissage du tableau de bits
+  unsigned short b[48];
+  for(int ip=0;ip<48;ip++) {b[ip] = v&1; v = (v>>1);}
+  if(lp>2) {
+    cout<<"...b= ";
+    for(int ip=47;ip>=0;ip--) {if(ip==23) cout<<" "; cout<<b[ip];}
+    cout<<endl;
+  }
+
+  // Melange des bits qui varient vite (poids faible, microsec)
+  //   avec ceux variant lentement (poids fort, sec)
+  // On coupe le mot en trois: bits[0-15], bits[16-31] et bits[32-47]
+  // On echange 2 bits sur 3 du mot bits[0-15] dans les autres mots
+  //    bit0  <-> bit0  , bit1  <-> bit17 , bit2  <-> bit34
+  //    bit3  <-> bit3  , bit4  <-> bit20 , bit5  <-> bit37
+  //    bit13 <-> bit13 , bit14 <-> bit30 , bit15 <-> bit47
+  for(int ip=0;ip<16;ip++) {
+    if(ip%3==0) continue;
+    int ipd = (ip%3==1)? 16+ip : 32+ip;
+    unsigned short w = b[ip];
+    //cout<<"swap g["<<ip<<"]="<<b[ip]<<" <-> b["<<ipd<<"]="<<b[ipd]<<endl;
+    b[ip] = b[ipd];
+    b[ipd] = w;
+  }
+  if(lp>2) {
+    cout<<"...b= ";
+    for(int ip=47;ip>=0;ip--) {if(ip==23) cout<<" "; cout<<b[ip];}
+    cout<<endl;
+  }
+
+  // Construction du tableau d'initialisation
+  unsigned short seed_16v[3] = {0,0,0};
+  for(int is=0;is<3;is++) {
+    unsigned short w = 1;
+    for(int ip=0;ip<16;ip++) {
+      seed_16v[is] += w*b[is*16+ip];
+      w *= 2;
+    }
+  }
+  if(lp>0) cout<<"RandomGenerator::AutoInit: "<<seed_16v[0]<<" "<<seed_16v[1]<<" "<<seed_16v[2]<<endl;
+
+  // Initialise drand48()
+  Init(seed_16v,lp);
 }
 