Index: trunk/SophyaLib/Samba/Makefile
===================================================================
--- trunk/SophyaLib/Samba/Makefile	(revision 3205)
+++ trunk/SophyaLib/Samba/Makefile	(revision 3405)
@@ -11,6 +11,5 @@
 	touch $(SOPHYAINCP)/SophyaConfInfo/libsophya.objlist
  
-$(SOPHYAOBJP)alm.o: alm.cc \
-  $(SOPHYAINCP)sopnamsp.h alm.h \
+$(SOPHYAOBJP)alm.o: alm.cc $(SOPHYAINCP)sopnamsp.h alm.h \
   $(SOPHYAINCP)srandgen.h \
   $(SOPHYAINCP)machdefs.h \
@@ -39,6 +38,5 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  alm.cc
  
-$(SOPHYAOBJP)bruit.o: bruit.cc \
-  $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)bruit.o: bruit.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)fmath.h bruit.h \
   $(SOPHYAINCP)srandgen.h \
@@ -46,54 +44,54 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  bruit.cc
  
-$(SOPHYAOBJP)circle.o: circle.cc \
-  $(SOPHYAINCP)sopnamsp.h circle.h \
-  $(SOPHYAINCP)vector3d.h \
-  $(SOPHYAINCP)longlat.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)utilgeom.h \
-  $(SOPHYAINCP)unitvector.h \
-  geometry.h
+$(SOPHYAOBJP)circle.o: circle.cc $(SOPHYAINCP)sopnamsp.h \
+  circle.h $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)longlat.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)utilgeom.h \
+  $(SOPHYAINCP)unitvector.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)utilgeom.h geometry.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  circle.cc
  
 $(SOPHYAOBJP)datacirclefake.o: datacirclefake.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  datacirclefake.h datacirclebase.h circle.h \
-  $(SOPHYAINCP)vector3d.h \
-  $(SOPHYAINCP)longlat.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)utilgeom.h \
-  $(SOPHYAINCP)unitvector.h \
-  geometry.h
+  $(SOPHYAINCP)sopnamsp.h datacirclefake.h \
+  datacirclebase.h circle.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)longlat.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)utilgeom.h \
+  $(SOPHYAINCP)unitvector.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)utilgeom.h geometry.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  datacirclefake.cc
  
-$(SOPHYAOBJP)harmspher.o: harmspher.cc \
-  $(SOPHYAINCP)machdefs.h \
+$(SOPHYAOBJP)harmspher.o: harmspher.cc $(SOPHYAINCP)machdefs.h \
   harmspher.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  harmspher.cc
  
 $(SOPHYAOBJP)lambdaBuilder.o: lambdaBuilder.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  lambdaBuilder.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tmatrix_tsnl.h \
-  $(SOPHYAINCP)tvector_tsnl.h \
-  alm.h $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)sopnamsp.h lambdaBuilder.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector_tsnl.h alm.h \
+  $(SOPHYAINCP)srandgen.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)smathconst.h \
@@ -102,6 +100,5 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  lambdaBuilder.cc
  
-$(SOPHYAOBJP)mlobe.o: mlobe.cc \
-  $(SOPHYAINCP)sopnamsp.h mlobe.h \
+$(SOPHYAOBJP)mlobe.o: mlobe.cc $(SOPHYAINCP)sopnamsp.h mlobe.h \
   $(SOPHYAINCP)sphericalmap.h \
   $(SOPHYAINCP)smathconst.h \
@@ -133,11 +130,10 @@
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)unitvector.h \
   $(SOPHYAINCP)timing.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  mlobe.cc
  
-$(SOPHYAOBJP)sambainit.o: sambainit.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  sambainit.h \
-  $(SOPHYAINCP)skymapinit.h \
+$(SOPHYAOBJP)sambainit.o: sambainit.cc $(SOPHYAINCP)sopnamsp.h \
+  sambainit.h $(SOPHYAINCP)skymapinit.h \
   $(SOPHYAINCP)sophyainit.h \
   $(SOPHYAINCP)machdefs.h \
@@ -146,13 +142,14 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  sambainit.cc
  
-$(SOPHYAOBJP)scan.o: scan.cc \
-  $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)scan.o: scan.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h scan.h \
   $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)ppersist.h \
   $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)objfio.h \
@@ -162,4 +159,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)fiondblock.h \
+  $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)smathconst.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  scan.cc
@@ -171,4 +169,5 @@
   $(SOPHYAINCP)sphericalmap.h \
   $(SOPHYAINCP)smathconst.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pixelmap.h \
   $(SOPHYAINCP)ppersist.h \
@@ -198,9 +197,11 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)fftservintf.h \
-  $(SOPHYAINCP)fftpserver.h alm.h \
+  $(SOPHYAINCP)fftpserver.h \
+  $(SOPHYAINCP)fftservintf.h alm.h \
   $(SOPHYAINCP)srandgen.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)triangmtx.h \
-  lambdaBuilder.h \
+  $(SOPHYAINCP)tvector.h lambdaBuilder.h \
+  $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)timing.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  sphericaltransformserver.cc
Index: trunk/SophyaLib/Samba/smakefile
===================================================================
--- trunk/SophyaLib/Samba/smakefile	(revision 3205)
+++ trunk/SophyaLib/Samba/smakefile	(revision 3405)
@@ -11,6 +11,5 @@
 	touch $(SOPHYAINCP)/SophyaConfInfo/libsophya.objlist
  
-$(SOPHYAOBJP)alm.o: alm.cc \
-  $(SOPHYAINCP)sopnamsp.h alm.h \
+$(SOPHYAOBJP)alm.o: alm.cc $(SOPHYAINCP)sopnamsp.h alm.h \
   $(SOPHYAINCP)srandgen.h \
   $(SOPHYAINCP)machdefs.h \
@@ -39,6 +38,5 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  alm.cc
  
-$(SOPHYAOBJP)bruit.o: bruit.cc \
-  $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)bruit.o: bruit.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)fmath.h bruit.h \
   $(SOPHYAINCP)srandgen.h \
@@ -46,54 +44,54 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  bruit.cc
  
-$(SOPHYAOBJP)circle.o: circle.cc \
-  $(SOPHYAINCP)sopnamsp.h circle.h \
-  $(SOPHYAINCP)vector3d.h \
-  $(SOPHYAINCP)longlat.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)utilgeom.h \
-  $(SOPHYAINCP)unitvector.h \
-  geometry.h
+$(SOPHYAOBJP)circle.o: circle.cc $(SOPHYAINCP)sopnamsp.h \
+  circle.h $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)longlat.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)utilgeom.h \
+  $(SOPHYAINCP)unitvector.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)utilgeom.h geometry.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  circle.cc
  
 $(SOPHYAOBJP)datacirclefake.o: datacirclefake.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  datacirclefake.h datacirclebase.h circle.h \
-  $(SOPHYAINCP)vector3d.h \
-  $(SOPHYAINCP)longlat.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)utilgeom.h \
-  $(SOPHYAINCP)unitvector.h \
-  geometry.h
+  $(SOPHYAINCP)sopnamsp.h datacirclefake.h \
+  datacirclebase.h circle.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)longlat.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)utilgeom.h \
+  $(SOPHYAINCP)unitvector.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)utilgeom.h geometry.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  datacirclefake.cc
  
-$(SOPHYAOBJP)harmspher.o: harmspher.cc \
-  $(SOPHYAINCP)machdefs.h \
+$(SOPHYAOBJP)harmspher.o: harmspher.cc $(SOPHYAINCP)machdefs.h \
   harmspher.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  harmspher.cc
  
 $(SOPHYAOBJP)lambdaBuilder.o: lambdaBuilder.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  lambdaBuilder.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tmatrix_tsnl.h \
-  $(SOPHYAINCP)tvector_tsnl.h \
-  alm.h $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)sopnamsp.h lambdaBuilder.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector_tsnl.h alm.h \
+  $(SOPHYAINCP)srandgen.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)smathconst.h \
@@ -102,6 +100,5 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  lambdaBuilder.cc
  
-$(SOPHYAOBJP)mlobe.o: mlobe.cc \
-  $(SOPHYAINCP)sopnamsp.h mlobe.h \
+$(SOPHYAOBJP)mlobe.o: mlobe.cc $(SOPHYAINCP)sopnamsp.h mlobe.h \
   $(SOPHYAINCP)sphericalmap.h \
   $(SOPHYAINCP)smathconst.h \
@@ -133,11 +130,10 @@
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)unitvector.h \
   $(SOPHYAINCP)timing.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  mlobe.cc
  
-$(SOPHYAOBJP)sambainit.o: sambainit.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  sambainit.h \
-  $(SOPHYAINCP)skymapinit.h \
+$(SOPHYAOBJP)sambainit.o: sambainit.cc $(SOPHYAINCP)sopnamsp.h \
+  sambainit.h $(SOPHYAINCP)skymapinit.h \
   $(SOPHYAINCP)sophyainit.h \
   $(SOPHYAINCP)machdefs.h \
@@ -146,13 +142,14 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  sambainit.cc
  
-$(SOPHYAOBJP)scan.o: scan.cc \
-  $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)scan.o: scan.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h scan.h \
   $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)ppersist.h \
   $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)objfio.h \
@@ -162,4 +159,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)fiondblock.h \
+  $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)smathconst.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  scan.cc
@@ -171,4 +169,5 @@
   $(SOPHYAINCP)sphericalmap.h \
   $(SOPHYAINCP)smathconst.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pixelmap.h \
   $(SOPHYAINCP)ppersist.h \
@@ -198,9 +197,11 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)fftservintf.h \
-  $(SOPHYAINCP)fftpserver.h alm.h \
+  $(SOPHYAINCP)fftpserver.h \
+  $(SOPHYAINCP)fftservintf.h alm.h \
   $(SOPHYAINCP)srandgen.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)triangmtx.h \
-  lambdaBuilder.h \
+  $(SOPHYAINCP)tvector.h lambdaBuilder.h \
+  $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)timing.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  sphericaltransformserver.cc