Index: trunk/SophyaLib/HiStats/Makefile
===================================================================
--- trunk/SophyaLib/HiStats/Makefile	(revision 3392)
+++ trunk/SophyaLib/HiStats/Makefile	(revision 3407)
@@ -4,5 +4,5 @@
  
 clean:
-	 rm -f $(SOPHYAOBJP)basedtable.o $(SOPHYAOBJP)datatable.o $(SOPHYAOBJP)fio_dtable.o $(SOPHYAOBJP)hisprof.o $(SOPHYAOBJP)hist2err.o $(SOPHYAOBJP)histerr.o $(SOPHYAOBJP)histinit.o $(SOPHYAOBJP)histos2.o $(SOPHYAOBJP)histos.o $(SOPHYAOBJP)ntupintf.o $(SOPHYAOBJP)ntuple.o $(SOPHYAOBJP)proxtuple.o $(SOPHYAOBJP)swppfdtable.o $(SOPHYAOBJP)xntuple.o
+	 rm -f $(SOPHYAOBJP)basedtable.o $(SOPHYAOBJP)datatable.o $(SOPHYAOBJP)fio_dtable.o $(SOPHYAOBJP)hisprof.o $(SOPHYAOBJP)hist2err.o $(SOPHYAOBJP)histerr.o $(SOPHYAOBJP)histinit.o $(SOPHYAOBJP)histos.o $(SOPHYAOBJP)histos2.o $(SOPHYAOBJP)ntupintf.o $(SOPHYAOBJP)ntuple.o $(SOPHYAOBJP)proxtuple.o $(SOPHYAOBJP)swppfdtable.o $(SOPHYAOBJP)xntuple.o
 	rm -f $(SOPHYALIBP)libHiStats.a
  
@@ -12,90 +12,92 @@
  
 $(SOPHYAOBJP)basedtable.o: basedtable.cc basedtable.h \
-  $(SOPHYAINCP)machdefs.h \
-  ntupintf.h $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)segdatablock.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tmatrix_tsnl.h \
-  $(SOPHYAINCP)tvector_tsnl.h \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)pexceptions.h
+  $(SOPHYAINCP)machdefs.h ntupintf.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)segdatablock.h \
+  $(SOPHYAINCP)thsafeop.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)thsafeop.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  basedtable.cc
  
 $(SOPHYAOBJP)datatable.o: datatable.cc datatable.h basedtable.h \
-  $(SOPHYAINCP)machdefs.h \
-  ntupintf.h $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)segdatablock.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tmatrix_tsnl.h \
-  $(SOPHYAINCP)tvector_tsnl.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h ntupintf.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)segdatablock.h \
+  $(SOPHYAINCP)thsafeop.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)strutil.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)fiosegdb.h \
   $(SOPHYAINCP)segdatablock.h \
-  $(SOPHYAINCP)ppftpointerio.h
+  $(SOPHYAINCP)ppftpointerio.h \
+  $(SOPHYAINCP)thsafeop.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  datatable.cc
  
 $(SOPHYAOBJP)fio_dtable.o: fio_dtable.cc datatable.h basedtable.h \
-  $(SOPHYAINCP)machdefs.h \
-  ntupintf.h $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)segdatablock.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tmatrix_tsnl.h \
-  $(SOPHYAINCP)tvector_tsnl.h \
-  $(SOPHYAINCP)objfio.h \
-  swppfdtable.h \
+  $(SOPHYAINCP)machdefs.h ntupintf.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)segdatablock.h \
+  $(SOPHYAINCP)thsafeop.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)objfio.h swppfdtable.h \
   $(SOPHYAINCP)swsegdb.h \
   $(SOPHYAINCP)segdatablock.h \
@@ -103,12 +105,9 @@
   $(SOPHYAINCP)swsegdb.h \
   $(SOPHYAINCP)ppftpointerio.h \
-  $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)fiosegdb.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  fio_dtable.cc
  
-$(SOPHYAOBJP)hisprof.o: hisprof.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
+$(SOPHYAOBJP)hisprof.o: hisprof.cc $(SOPHYAINCP)machdefs.h \
   hisprof.h $(SOPHYAINCP)peida.h \
   $(SOPHYAINCP)machdefs.h \
@@ -141,7 +140,5 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  hisprof.cc
  
-$(SOPHYAOBJP)hist2err.o: hist2err.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
+$(SOPHYAOBJP)hist2err.o: hist2err.cc $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)perrors.h \
   $(SOPHYAINCP)pexceptions.h \
@@ -165,12 +162,10 @@
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tvector_tsnl.h \
-  hist2err.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)tvector_tsnl.h hist2err.h \
+  $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)tmatrix.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  hist2err.cc
  
-$(SOPHYAOBJP)histerr.o: histerr.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
+$(SOPHYAOBJP)histerr.o: histerr.cc $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)perrors.h \
   $(SOPHYAINCP)pexceptions.h \
@@ -194,13 +189,11 @@
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tvector_tsnl.h \
-  histerr.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)tvector_tsnl.h histerr.h \
+  $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)tvector.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  histerr.cc
  
-$(SOPHYAOBJP)histinit.o: histinit.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  histinit.h \
+$(SOPHYAOBJP)histinit.o: histinit.cc $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h histinit.h \
   $(SOPHYAINCP)ntoolsinit.h \
   $(SOPHYAINCP)tarrinit.h \
@@ -232,12 +225,11 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)anydataobj.h \
-  histos2.h $(SOPHYAINCP)utils.h \
-  hisprof.h histerr.h hist2err.h \
-  $(SOPHYAINCP)tmatrix.h ntuple.h \
-  ntupintf.h $(SOPHYAINCP)dvlist.h \
-  xntuple.h datatable.h basedtable.h \
-  $(SOPHYAINCP)segdatablock.h \
-  swppfdtable.h \
+  $(SOPHYAINCP)anydataobj.h histos2.h \
+  $(SOPHYAINCP)utils.h hisprof.h histerr.h \
+  hist2err.h $(SOPHYAINCP)tmatrix.h ntuple.h \
+  ntupintf.h $(SOPHYAINCP)dvlist.h xntuple.h \
+  datatable.h basedtable.h \
+  $(SOPHYAINCP)segdatablock.h \
+  $(SOPHYAINCP)thsafeop.h swppfdtable.h \
   $(SOPHYAINCP)swsegdb.h \
   $(SOPHYAINCP)segdatablock.h \
@@ -247,7 +239,40 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  histinit.cc
  
-$(SOPHYAOBJP)histos2.o: histos2.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
+$(SOPHYAOBJP)histos.o: histos.cc $(SOPHYAINCP)machdefs.h \
+  histos.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)peida.h \
+  $(SOPHYAINCP)utils.h \
+  $(SOPHYAINCP)perrors.h \
+  $(SOPHYAINCP)fmath.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)perrors.h \
+  $(SOPHYAINCP)poly.h \
+  $(SOPHYAINCP)peida.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)strutil.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  histos.cc
+ 
+$(SOPHYAOBJP)histos2.o: histos2.cc $(SOPHYAINCP)machdefs.h \
   histos2.h $(SOPHYAINCP)peida.h \
   $(SOPHYAINCP)machdefs.h \
@@ -280,52 +305,11 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  histos2.cc
  
-$(SOPHYAOBJP)histos.o: histos.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h histos.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)peida.h \
-  $(SOPHYAINCP)utils.h \
-  $(SOPHYAINCP)perrors.h \
-  $(SOPHYAINCP)fmath.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tmatrix_tsnl.h \
-  $(SOPHYAINCP)tvector_tsnl.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)perrors.h \
-  $(SOPHYAINCP)poly.h \
-  $(SOPHYAINCP)peida.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)strutil.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  histos.cc
- 
-$(SOPHYAOBJP)ntupintf.o: ntupintf.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  ntupintf.h \
-  $(SOPHYAINCP)machdefs.h \
+$(SOPHYAOBJP)ntupintf.o: ntupintf.cc $(SOPHYAINCP)sopnamsp.h \
+  ntupintf.h $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)machdefs.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  ntupintf.cc
  
-$(SOPHYAOBJP)ntuple.o: ntuple.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)strutil.h \
+$(SOPHYAOBJP)ntuple.o: ntuple.cc $(SOPHYAINCP)strutil.h \
   $(SOPHYAINCP)perrors.h \
   $(SOPHYAINCP)pexceptions.h \
@@ -337,27 +321,24 @@
   $(SOPHYAINCP)ppfbinstream.h \
   $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  ntupintf.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h
+  $(SOPHYAINCP)ppfnametag.h ntupintf.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)thsafeop.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  ntuple.cc
  
-$(SOPHYAOBJP)proxtuple.o: proxtuple.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  proxtuple.h ntuple.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  ntupintf.h \
+$(SOPHYAOBJP)proxtuple.o: proxtuple.cc $(SOPHYAINCP)sopnamsp.h \
+  proxtuple.h ntuple.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h ntupintf.h \
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)ppersist.h \
@@ -369,18 +350,19 @@
  
 $(SOPHYAOBJP)swppfdtable.o: swppfdtable.cc swppfdtable.h basedtable.h \
-  $(SOPHYAINCP)machdefs.h \
-  ntupintf.h $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)segdatablock.h \
+  $(SOPHYAINCP)machdefs.h ntupintf.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)segdatablock.h \
+  $(SOPHYAINCP)thsafeop.h \
   $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)tmatrix.h \
@@ -398,11 +380,9 @@
   $(SOPHYAINCP)ppftpointerio.h \
   $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)pexceptions.h
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)thsafeop.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  swppfdtable.cc
  
-$(SOPHYAOBJP)xntuple.o: xntuple.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)ppersist.h \
+$(SOPHYAOBJP)xntuple.o: xntuple.cc $(SOPHYAINCP)ppersist.h \
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
@@ -413,6 +393,6 @@
   $(SOPHYAINCP)ppersist.h \
   $(SOPHYAINCP)perrors.h xntuple.h \
-  $(SOPHYAINCP)machdefs.h \
-  ntupintf.h $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)machdefs.h ntupintf.h \
+  $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)anydataobj.h \
Index: trunk/SophyaLib/HiStats/smakefile
===================================================================
--- trunk/SophyaLib/HiStats/smakefile	(revision 3392)
+++ trunk/SophyaLib/HiStats/smakefile	(revision 3407)
@@ -36,6 +36,6 @@
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)pexceptions.h
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)thsafeop.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  basedtable.cc
  
@@ -66,10 +66,10 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)strutil.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)fiosegdb.h \
   $(SOPHYAINCP)segdatablock.h \
-  $(SOPHYAINCP)ppftpointerio.h
+  $(SOPHYAINCP)ppftpointerio.h \
+  $(SOPHYAINCP)thsafeop.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  datatable.cc
  
@@ -327,5 +327,6 @@
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)thsafeop.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  ntuple.cc
  
@@ -379,6 +380,6 @@
   $(SOPHYAINCP)ppftpointerio.h \
   $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)pexceptions.h
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)thsafeop.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  swppfdtable.cc
  