Index: trunk/SophyaLib/NTools/classfunc.h
===================================================================
--- trunk/SophyaLib/NTools/classfunc.h	(revision 3406)
+++ trunk/SophyaLib/NTools/classfunc.h	(revision 3409)
@@ -14,5 +14,5 @@
 public:
   virtual ~ClassFunc(void) { }
-  virtual double operator()(double x) const =0;
+  virtual double operator()(double x) =0;
 };
 
@@ -23,5 +23,5 @@
  public:
   Function(double (*g)(double)):f(g){}
-  virtual  double operator()(double x) const { return f(x);}
+  virtual  double operator()(double x) { return f(x);}
 };
 
Index: trunk/SophyaLib/NTools/genericfunc.h
===================================================================
--- trunk/SophyaLib/NTools/genericfunc.h	(revision 3406)
+++ trunk/SophyaLib/NTools/genericfunc.h	(revision 3409)
@@ -9,30 +9,30 @@
 
 //! Abstract interface definition for functions viewed as classes
-class GenericFunc : public ClassFunc {
+  class GenericFunc : public ClassFunc {
 public:
   GenericFunc(void) { }
   virtual ~GenericFunc(void) { }
 
-  virtual double operator()(double x) const {
+  virtual double operator()(double x) {
     cout<<"GenericFunc::operator(double) not implemented"<<endl;
     throw NotAvailableOperation("GenericFunc::operator(double) not implemented");
   }
 
-  virtual double operator()(double x,double y) const {
+  virtual double operator()(double x,double y) {
     cout<<"GenericFunc::operator(double,double) not implemented"<<endl;
     throw NotAvailableOperation("GenericFunc::operator(double,double) not implemented");
   }
 
-  virtual double operator()(double x,double y,double z) const {
+  virtual double operator()(double x,double y,double z) {
     cout<<"GenericFunc::operator(double,double,double) not implemented"<<endl;
     throw NotAvailableOperation("GenericFunc::operator(double,double,double) not implemented");
   }
 
-  virtual double operator()(double* x) const {
+  virtual double operator()(double* x) {
     cout<<"GenericFunc::operator(double*) not implemented"<<endl;
     throw NotAvailableOperation("GenericFunc::operator(double*) not implemented");
   }
 
-  virtual double operator()(vector<double>& x) const {
+  virtual double operator()(vector<double>& x) {
     cout<<"GenericFunc::operator(vector<double>&) not implemented"<<endl;
     throw NotAvailableOperation("GenericFunc::operator(vector<double>&) not implemented");
Index: trunk/SophyaLib/NTools/integ.cc
===================================================================
--- trunk/SophyaLib/NTools/integ.cc	(revision 3406)
+++ trunk/SophyaLib/NTools/integ.cc	(revision 3409)
@@ -35,5 +35,5 @@
 
 //! Constructeur à partir d'une classe-fonction, et des bornes d'intégration.
-Integrator::Integrator(ClassFunc const & f, double xmin, double xmax)
+Integrator::Integrator(ClassFunc & f, double xmin, double xmax)
 : mFunc(NULL), mClFun(&f), mGFF(NULL), mGFFParm(NULL),
   mNStep(50), mDX(-1), mReqPrec(-1),
@@ -54,5 +54,5 @@
   à [0,1], et on pourra les modifier plus tard.
 */
-Integrator::Integrator(ClassFunc const & f)
+Integrator::Integrator(ClassFunc & f)
 : mFunc(NULL), mClFun(&f), mGFF(NULL), mGFFParm(NULL),
   mNStep(50), mDX(-1), mReqPrec(-1),
@@ -159,5 +159,5 @@
 //! Spécifie la fonction à intégrer, sous forme double f(double).
 Integrator& 
-Integrator::SetFunc(ClassFunc const & f)
+Integrator::SetFunc(ClassFunc & f)
 {
   mFunc = NULL;
@@ -239,5 +239,5 @@
 {}
 
-TrpzInteg::TrpzInteg(ClassFunc const & f, double xmin, double xmax)
+TrpzInteg::TrpzInteg(ClassFunc & f, double xmin, double xmax)
 : Integrator(f, xmin, xmax)
 {}
@@ -247,5 +247,5 @@
 {}
 
-TrpzInteg::TrpzInteg(ClassFunc const & f)
+TrpzInteg::TrpzInteg(ClassFunc & f)
 : Integrator(f)
 {}
@@ -320,5 +320,5 @@
 
 
-GLInteg::GLInteg(ClassFunc const & f, double xmin, double xmax)
+GLInteg::GLInteg(ClassFunc & f, double xmin, double xmax)
 : Integrator(f, xmin, xmax), mXPos(NULL), mWeights(NULL), mOrder(8)
 {
@@ -332,5 +332,5 @@
 }
 
-GLInteg::GLInteg(ClassFunc const & f)
+GLInteg::GLInteg(ClassFunc & f)
 : Integrator(f), mXPos(NULL), mWeights(NULL), mOrder(8)
 {
Index: trunk/SophyaLib/NTools/integ.h
===================================================================
--- trunk/SophyaLib/NTools/integ.h	(revision 3406)
+++ trunk/SophyaLib/NTools/integ.h	(revision 3409)
@@ -21,6 +21,6 @@
 
   Integrator();
-  Integrator(ClassFunc const &, double xmin, double xmax);
-  Integrator(ClassFunc const &);
+  Integrator(ClassFunc &, double xmin, double xmax);
+  Integrator(ClassFunc &);
 
   Integrator(FUNC, double xmin, double xmax);
@@ -39,5 +39,5 @@
   virtual Integrator& ReqPrec(double);   // NOT YET !
   virtual Integrator& Limits(double xmin, double xmax);
-  virtual Integrator& SetFunc(ClassFunc const &);
+  virtual Integrator& SetFunc(ClassFunc &);
   virtual Integrator& SetFunc(FUNC);
   virtual Integrator& SetFunc(GeneralFunction*, double* par);
@@ -48,5 +48,5 @@
 protected:
   FUNC             mFunc;
-  ClassFunc const* mClFun;
+  ClassFunc *      mClFun;
   GeneralFunction* mGFF;
   double*          mGFFParm;
@@ -68,6 +68,6 @@
 public:
   TrpzInteg();
-  TrpzInteg(ClassFunc const &, double xmin, double xmax);
-  TrpzInteg(ClassFunc const &);
+  TrpzInteg(ClassFunc  &, double xmin, double xmax);
+  TrpzInteg(ClassFunc  &);
   TrpzInteg(FUNC, double xmin, double xmax);
   TrpzInteg(FUNC);
@@ -83,6 +83,6 @@
 public:
   GLInteg();
-  GLInteg(ClassFunc const &, double xmin, double xmax);
-  GLInteg(ClassFunc const &);
+  GLInteg(ClassFunc  &, double xmin, double xmax);
+  GLInteg(ClassFunc  &);
   GLInteg(FUNC, double xmin, double xmax);
   GLInteg(FUNC);