Index: trunk/SophyaExt/IFFTW/fftw3server.cc
===================================================================
--- trunk/SophyaExt/IFFTW/fftw3server.cc	(revision 3411)
+++ trunk/SophyaExt/IFFTW/fftw3server.cc	(revision 3412)
@@ -56,5 +56,5 @@
     int sz[MAXND_FFTW];
     FillSizes4FFTW(in, sz);
-    fftw_plan p = fftw_plan_dft(rank, sz,
+    fftw_plan p = fftw_plan_dft(in.NbDimensions(), sz,
 		      (fftw_complex *)in.Data(), (fftw_complex *)out.Data(), 
 		      FFTW_FORWARD, FFTW_ESTIMATE);
@@ -86,5 +86,5 @@
     int sz[MAXND_FFTW];
     FillSizes4FFTW(in, sz);
-    fftw_plan p = fftw_plan_dft(rank, sz,
+    fftw_plan p = fftw_plan_dft(in.NbDimensions(), sz,
 				(fftw_complex *)in.Data(), (fftw_complex *)out.Data(), 
 				FFTW_BACKWARD, FFTW_ESTIMATE);
@@ -104,6 +104,5 @@
   if (rank == 1) { // One dimensional transform 
     fftw_plan p = fftw_plan_dft_r2c_1d(in.Size(), in.Data(), 
-				       (fftw_complex *)out.Data(),
-				       FFTW_ESTIMATE);  
+				       (fftw_complex *)out.Data(), FFTW_ESTIMATE);  
     if (p == NULL) 
       throw ParmError("FFTWServer::FFTForward(r_8, complex<r_8> ) Error creating fftw_plan"); 
@@ -118,7 +117,6 @@
     int sz[MAXND_FFTW];
     FillSizes4FFTW(in, sz);
-    fftw_plan p = fftw_plan_dft_r2c(rank, sz, in.Data(),
-				      (fftw_complex *)out.Data(),
-				      FFTW_ESTIMATE);
+    fftw_plan p = fftw_plan_dft_r2c(in.NbDimensions(), sz, in.Data(),
+				    (fftw_complex *)out.Data(), FFTW_ESTIMATE);
     if (p == NULL) 
       throw ParmError("FFTWServer::FFTForward(r_8, complex<r_8> ) Error creating fftw_plan"); 
@@ -143,6 +141,5 @@
   if (rank == 1) { // One dimensional transform 
     fftw_plan p = fftw_plan_dft_c2r_1d(out.Size(), (fftw_complex *)inp.Data(), 
-			     out.Data(),
-			     FFTW_ESTIMATE);  
+			     out.Data(), FFTW_ESTIMATE);  
     if (p == NULL) 
       throw ParmError("FFTWServer::FFTBackward(r_8, complex<r_8> ) Error creating fftw_plan"); 
@@ -155,7 +152,6 @@
     int sz[MAXND_FFTW];
     FillSizes4FFTW(out, sz);
-    fftw_plan p = fftw_plan_dft_c2r(rank, sz, (fftw_complex *)inp.Data(), 
-			  out.Data(),
-			  FFTW_ESTIMATE);  
+    fftw_plan p = fftw_plan_dft_c2r(out.NbDimensions(), sz, (fftw_complex *)inp.Data(), 
+				    out.Data(), FFTW_ESTIMATE);  
     if (p == NULL) 
       throw ParmError("FFTWServer::FFTBackward(r_8, complex<r_8> ) Error creating fftw_plan"); 
@@ -249,5 +245,5 @@
     int sz[MAXND_FFTW];
     FillSizes4FFTW(in, sz);
-    fftwf_plan p = fftwf_plan_dft(rank, sz,
+    fftwf_plan p = fftwf_plan_dft(in.NbDimensions(), sz,
 		      (fftwf_complex *)in.Data(), (fftwf_complex *)out.Data(), 
 		      FFTW_FORWARD, FFTW_ESTIMATE);
@@ -279,5 +275,5 @@
     int sz[MAXND_FFTW];
     FillSizes4FFTW(in, sz);
-    fftwf_plan p = fftwf_plan_dft(rank, sz,
+    fftwf_plan p = fftwf_plan_dft(in.NbDimensions(), sz,
 				(fftwf_complex *)in.Data(), (fftwf_complex *)out.Data(), 
 				FFTW_BACKWARD, FFTW_ESTIMATE);
@@ -297,6 +293,5 @@
   if (rank == 1) { // One dimensional transform 
     fftwf_plan p = fftwf_plan_dft_r2c_1d(in.Size(), in.Data(), 
-				       (fftwf_complex *)out.Data(),
-				       FFTW_ESTIMATE);  
+					 (fftwf_complex *)out.Data(), FFTW_ESTIMATE);  
     if (p == NULL) 
       throw ParmError("FFTWServer::FFTForward(r_4, complex<r_4> ) Error creating fftwf_plan"); 
@@ -311,7 +306,6 @@
     int sz[MAXND_FFTW];
     FillSizes4FFTW(in, sz);
-    fftwf_plan p = fftwf_plan_dft_r2c(rank, sz, in.Data(),
-				      (fftwf_complex *)out.Data(),
-				      FFTW_ESTIMATE);
+    fftwf_plan p = fftwf_plan_dft_r2c(in.NbDimensions(), sz, in.Data(),
+				      (fftwf_complex *)out.Data(), FFTW_ESTIMATE);
     if (p == NULL) 
       throw ParmError("FFTWServer::FFTForward(r_4, complex<r_4> ) Error creating fftwf_plan"); 
@@ -336,6 +330,5 @@
   if (rank == 1) { // One dimensional transform 
     fftwf_plan p = fftwf_plan_dft_c2r_1d(out.Size(), (fftwf_complex *)inp.Data(), 
-			     out.Data(),
-			     FFTW_ESTIMATE);  
+					 out.Data(), FFTW_ESTIMATE);  
     if (p == NULL) 
       throw ParmError("FFTWServer::FFTBackward(r_4, complex<r_4> ) Error creating fftwf_plan"); 
@@ -348,7 +341,6 @@
     int sz[MAXND_FFTW];
     FillSizes4FFTW(out, sz);
-    fftwf_plan p = fftwf_plan_dft_c2r(rank, sz, (fftwf_complex *)inp.Data(), 
-			  out.Data(),
-			  FFTW_ESTIMATE);  
+    fftwf_plan p = fftwf_plan_dft_c2r(out.NbDimensions(), sz, (fftwf_complex *)inp.Data(), 
+			  out.Data(), FFTW_ESTIMATE);  
     if (p == NULL) 
       throw ParmError("FFTWServer::FFTBackward(r_4, complex<r_4> ) Error creating fftwf_plan"); 